#ifndef _LIBMPEG2DEC__H
#define _LIBMPEG2DEC__H

#ifdef __cplusplus  
extern "C" {
#endif

#define FTRACE 1
#define FQUIET 2

#define YUV420 0
#define YUV422 1
#define YUV444 2

#define PCYUYV 0
#define PCYVYU 1
#define PCUYVY 2
#define PCVYUY 3
#define BRCMYYCRCB	4

#define PCARGB 0
#define PCABGR 1
#define BRCMARGB 2

typedef int (*pfnMPEG2DecoderCallback) (unsigned char* src[], int ChromaFmt, int Progressive_frame, int mpeg2, int w, int h);

/* output 4CC YUYV variants, current gfx compositor does not support YUV surface */
/* 
void Convto422(unsigned char* src[], unsigned char* dst, int ChromaFmt, int Progressive_frame, int w, int h, int pitch, int fmt); 
void ConvYUYVToRGB32(unsigned char* src, int srcPitch, unsigned char* dst, int dstPitch, int w, int h, int mpeg2);
*/


/* (A)RGB32 and (A)BGR32 */
void ConvtoRGB32(unsigned char* src[], unsigned char* dst, int ChromaFmt, int Progressive_frame, int mpeg2, int w, int h, int pitch, int fmt);


int mpeg2decode(char* buf, int FileOrBuf, int len, pfnMPEG2DecoderCallback pfnCallback, int flags, int vflag);



#ifdef __cplusplus
}
#endif

#endif
 
