#!/bin/sh
# \
exec tclsh "$0" ${1+"$@"}

set incBomLine {f 0644 root root include/tcl/%s common/lib/tcl/generic/%s package=hdr arch=mips,ppc,x86 dest=sdk}

set libBomLine {f 0644 root root tvlib/tcl8.4/%s common/lib/tcl/library/%s package=jpm-tvlib arch=mips,ppc,x86 dest=sdk}

#
# Comment header block
#

puts {
# NOTE: this bom file was generated using generate-bom.tcl, do not modify
# directly

}

#
# Include files from ../generic
#
set incFiles {tcl.h}

foreach incFile $incFiles {
    puts [format $incBomLine $incFile $incFile]
}    

#
# Lib files
#

puts {f 0644 root root lib/libtcl8.4.a obj/$TIVO_SYSTEM/libtcl8.4.a package=lib arch=mips,ppc,x86 dest=sdk_lib}

puts {f 0644 root root lib/libtcl8.4.nm obj/$TIVO_SYSTEM/libtcl8.4.nm package=lib arch=mips,ppc,x86 dest=sdk_lib}

#
# Tcl library files from ../library
#
cd ../library

set libfiles [exec find . -name *]

foreach libfile $libfiles {
    if {![file isdirectory $libfile]} {
        
        set filepath [file split $libfile]
        
        #
        # remove leading ./
        #
        if {[lindex $filepath 0] == "."} {
            set filepath [lrange $filepath 1 end]
        }
        
        #
        # ignore the dde directory, it's for windows
        #
        if {[lindex $filepath 0] == "dde"} {
            continue
        }

        set libfile [eval file join $filepath]
        
        puts [format $libBomLine $libfile $libfile]
    }
}
