/* 
 * tclTivoInit.c --
 *
 *	Contains the Tivo-specific interpreter initialization functions.
 *
 * Copyright (c) 2004 TiVo, Inc.
 * All rights reserved.
 *
 */

#include "tclInt.h"
#include "tclPort.h"

int Tcl_TiVoGetLibraryPath(Tcl_Interp *interp,
                           int maxPathLen,
                           char *tclLibPath)
{
    char *root = getenv("TIVO_ROOT");
    
    if (root != NULL)
    {
        strncpy(tclLibPath, root, maxPathLen);
        if (root[strlen(root)] != '/')
        {
            strncat(tclLibPath, "/", maxPathLen);

            //
            // This adds the version number to the directory, which is
            // currently disabled because we want /tvlib/tcl/tv to
            // contains other stuff as well.
            //
            // strncat(tclLibPath, TIVO_TCL_VERSION, maxPathLen);
        }
        strncat(tclLibPath, "tvlib/tcl", maxPathLen);

        tclLibPath[maxPathLen] = '\0';
        return TCL_OK;
    }
    else
    {
        return Tcl_UnixGetLibraryPath(interp, maxPathLen, tclLibPath);
    }
}

int Tcl_TiVoGetPackagePath(Tcl_Interp *interp,
                           int maxPathLen,
                           char *tclPkgPath)
{
    char *root = getenv("TIVO_ROOT");
    
    if (root != NULL)
    {
        strncpy(tclPkgPath, root, maxPathLen);

        if (root[strlen(root)] != '/')
        {
            strncat(tclPkgPath, "/", maxPathLen);
        }
        strncat(tclPkgPath, "tvlib", maxPathLen);
        
        tclPkgPath[maxPathLen] = '\0';
        return TCL_OK;
    }
    else
    {
        return Tcl_UnixGetLibraryPath(interp, maxPathLen, tclPkgPath);
    }
}


